<?php    

if(!defined('ParticleTraffic_PATH')) die;

class ParticleTrafficCachedMonth { 

	protected $traffic_cached_month_id;
	protected $book_id;
	protected $datetime;
	protected $pageviews;
	protected $visits;
	
	public function __construct(){ 
		$this->db = ParticleTrafficDB::get_instance();
	}	
	
	static function retrieveList($WHERE='',$LIMIT='',$ORDER_BY){		
	
		if(strlen($LIMIT)){
			if( !strstr( strtolower($LIMIT),'limit') ) 
				$LIMIT=' limit '.$LIMIT;
		}else $LIMIT='';
		
		if(strlen($ORDER_BY)){
			if( !strstr( strtolower($ORDER_BY),'order by') ) 
				$ORDER_BY=' order by '.$ORDER_BY;
		}else $ORDER_BY='';
			
		if(strlen($WHERE)){
			if( !strstr( strtolower($WHERE),'where') ) 
				$WHERE=' where '.$WHERE;
		}else $WHERE='';			
		
		$sql='SELECT * FROM '.ParticleTrafficTracker::$cache_table .' '.$WHERE.' '.$ORDER_BY.' '.$LIMIT;
		$db = ParticleTrafficDB::get_instance();
		$rows=$db->get_array($sql);
		$cachedMonths=array();
		if(!is_array($rows) || !count($rows)) return $cachedMonths;
		foreach($rows as $row){
			$cachedMonth = new ParticleTrafficCachedMonth();
			$cachedMonth->array_to_object($row);
			$cachedMonths[]=$cachedMonth;
		}		
		return $cachedMonths;		
	}	

	//call any get method with a property type reference ($obj->property)
	public function __get($property){
		$method="get_{$property}";
		if(method_exists($this,$method)) return $this->$method();
	}
	
	function get_traffic_cached_month_id(){ return $this->traffic_cached_month_id;}
	function set_traffic_cached_month_id($traffic_cached_month_id){ $this->traffic_cached_month_id=$traffic_cached_month_id; }

	function get_book_id(){ return $this->book_id;}
	function set_book_id($book_id){ $this->book_id=$book_id; }

	function get_datetime(){ return $this->datetime;} 
	function set_datetime($datetime){ $this->datetime=$datetime; }

	function get_pageviews(){ return $this->pageviews;}
	function set_pageviews($pageviews){ $this->pageviews=$pageviews; }

	function get_visits(){ return $this->visits;}
	function set_visits($visits){ $this->visits=$visits; }

	function save(){
		if(!$this->traffic_cached_month_id) $this->create();
		else $this->update();
	}

	function create(){ 
		$sql="INSERT INTO ".ParticleTrafficTracker::$cache_table ." SET 
			book_id= ".intval($this->get_book_id() )." , 
			datetime= ".intval($this->get_datetime() )." ,
			pageviews= ".intval($this->get_pageviews() )." ,
			visits= ".intval($this->get_visits() )." ";
		$queryResult=$this->db->query($sql); 
		$this->set_traffic_cached_month_id( $this->db->maxID('traffic_cached_month_id',ParticleTrafficTracker::$cache_table) ); 
		if (!$queryResult) $queryResult=0; 
		return $queryResult;
	}
	
	function update(){ 
		$sql="UPDATE ".ParticleTrafficTracker::$cache_table ." SET 
		book_id= ".floatval($this->get_book_id()).",
		datetime= ".floatval($this->get_datetime()).",
		pageviews= ".floatval($this->get_pageviews()).",
		visits= ".floatval($this->get_visits())." WHERE ";
		$sql.= "traffic_cached_month_id=".$this->traffic_cached_month_id;
		$queryResult=$this->db->query($sql); 
		if (!$queryResult) $queryResult=0; 
		return $queryResult;
	}

	function delete(){
		throw new Exception('Cached month delete yet written');
	}	
	
	function array_to_object($ob_array){
		if( !is_array($ob_array) ) return;
		foreach($ob_array as $key=>$value){
			$set_method='set_'.$key;
			if ( method_exists($this,$set_method) )$this->$set_method($value);
		}
		return $this;
	}	
	
}

?>