<?php    

if(!defined('ParticleTraffic_PATH')) die;

class ParticleTrafficHit {

	protected $traffic_hits_id;
	protected $traffic_visits_id;
	protected $page_url;
	protected $page_url_short;
	protected $page_title;
	protected $created;

	public function __construct(){
		$this->db = ParticleTrafficDB::get_instance();
	}

	//call any get method with a property type reference ($obj->property)
	public function __get($property){
		$method="get_{$property}";
		if(method_exists($this,$method)) return $this->$method();
	}
	
	function get_traffic_hits_id(){ return $this->traffic_hits_id;}
	function set_traffic_hits_id($traffic_hits_id){ $this->traffic_hits_id=$traffic_hits_id; }

	function get_traffic_visits_id(){ return $this->traffic_visits_id;}
	function set_traffic_visits_id($traffic_visits_id){ $this->traffic_visits_id=$traffic_visits_id; }

	function get_page_url(){ return $this->page_url;}
	function set_page_url($page_url){ $this->page_url=$page_url; }

	function get_page_url_short(){ return $this->page_url_short;}
	function set_page_url_short($page_url_short){ $this->page_url_short=$page_url_short; }

	function get_page_title(){ return $this->page_title;}
	function set_page_title($page_title){ $this->page_title=$page_title; }

	function get_created(){ return $this->created;}
	function set_created($created){ $this->created=$created; }
	
	function save(){
		if(!$this->traffic_hits_id) $this->create();
		else $this->update();
	}	
	
	function create(){ 
		$this->set_created( time() );
		$sql="INSERT INTO ".ParticleTrafficTracker::$hits_table." SET  
			traffic_visits_id= ".intval($this->get_traffic_visits_id() )." ,
			page_url= '{$this->db->escape($this->get_page_url())}',
			page_url_short= '{$this->db->escape($this->get_page_url_short())}',
			page_title= '{$this->db->escape($this->get_page_title())}',
			created= ".intval($this->get_created() )." ";	
		$queryResult=$this->db->query($sql);
		if(!$queryResult) return 0; 
		$hid=$this->db->maxID('traffic_hits_id',ParticleTrafficTracker::$hits_table); 
		$this->set_traffic_hits_id( intval($hid) ); 
		return 1;
	}
	
	function update(){
		//not needed at this point - placeholder
		throw new Exception('ParticleTraffic hits update not yet written.');
	}	
	
	function delete(){
		$sql='DELETE FROM '.ParticleTrafficTracker::$hits_table.' WHERE traffic_hits_id = '.$this->get_traffic_hits_id();
		$this->db->query($sql); 
		$this->set_traffic_hits_id(-1); 
	}	

	function array_to_object($ob_array){
		if( !is_array($ob_array) ) return;
		foreach($ob_array as $key=>$value){
			$set_method='set_'.$key;
			if ( method_exists($this,$set_method) )$this->$set_method($value);
		} 
		return $this;
	}	

}

?>